package com.ircstuff.jbounce.config;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.xml.sax.helpers.*;
import org.xml.sax.*;

public class ConfigReader extends HandlerBase
{
	public static void main(String[] argv) {
		new ConfigReader(new Configuration(), new File(argv[0]));
		//new ConfigReader(null, "../resource/config.xml");
	}

	public ConfigReader(Configuration config, File file)
	{
		this(config, getStreamFor(file));
	}

	public ConfigReader(Configuration config, InputStream instream)
	{
		this.config = config;

		try
		{
			InputSource is = new InputSource(new BufferedReader(new InputStreamReader(instream)));
			SAXParserFactory.newInstance().newSAXParser().parse(is, this);
		}
		catch (SAXException t1)
		{
			t1.printStackTrace();
		}
		catch (Exception t2)
		{
			t2.printStackTrace();
		}
	}

	private static InputStream getStreamFor(File file)
	{
		try { return new FileInputStream(file); }
		catch(IOException e) { e.printStackTrace(); }
		return null;
	}

	/*
	private static InputStream getStreamFor(String filename)
	{
		return getStreamFor(new File(filename));
	}
	*/

	public void startDocument() throws SAXException { }
	public void endDocument() throws SAXException { }

	public void startElement(String name, AttributeList attrs) throws SAXException
	{
		try
		{

		if (name.equals("listen")) {
			try {
				config.addListen(
					attrs.getValue("iface"),
					Integer.parseInt(attrs.getValue("port"))
				);
			}
			catch (NumberFormatException e) { e.printStackTrace(); }
		}
		else if (name.equals("server")) {
			Server server = new Server(
				attrs.getValue("class"),
				attrs.getValue("name"),
				attrs.getValue("address")
			);
			config.addServer(server);
		}
		else if (name.equals("user")) {
			currentUser = new User(
				attrs.getValue("id"),
				attrs.getValue("password")
			);
			config.addUser(currentUser);
		}
		else if (name.equals("hostmask")) {
			hostmask = "";
		}
		else if (name.equals("connect")) {
			currentUser.addConnection(
				attrs.getValue("from"),
				attrs.getValue("to"),
				"yes".equals(attrs.getValue("default"))
			);
		}
		}
		catch (Exception e)
		{
			if (e instanceof SAXException) throw (SAXException) e;
			e.printStackTrace();
		}
	}

	public void endElement(String name) throws SAXException
	{
		try
		{

		if (name.equals("hostmask")) {
			currentUser.addHost(hostmask);
		}

		}
		catch (Exception e)
		{
			if (e instanceof SAXException) throw (SAXException) e;
			e.printStackTrace();
		}
	}

	public void characters(char buf [], int offset, int len) throws SAXException
	{
		String s = new String(buf, offset, len);
		hostmask += s;
	}

	private Configuration config;
	private String hostmask;
	private User currentUser;
}
