package com.ircstuff.jbounce.config;

import com.ircstuff.jbounce.util.StringUtil;

import java.util.*;

public class User
{
	public User(String id, String password)
	{
		this.id = id;
		this.password = password;
	}

	public String toString() { return id; }

	public void addHost(String host)
	{
		hosts.add(host);
	}

	public boolean matchesPass(String pass)
	{
		return password.equals(pass);
	}

	public boolean matchesHost(String host)
	{
		for (Enumeration e=hosts.elements(); e.hasMoreElements();)
		{
			String mask = (String)e.nextElement();
			if (StringUtil.wildmatch(mask, host))
			{
				System.out.println("["+host+"] matches ["+mask+"]");
				return true;
			}
			else
			{
				System.out.println("["+host+"] doesn't match ["+mask+"]");
			}
		}
		return false;
	}

	public void addConnection(String from, String to)
	{ addConnection(from, to, false); }
	public void addConnection(String from, String to, boolean isDefault)
	{ connections.add(new Connection(from, to, isDefault)); }

	public Connection getDefaultConnection()
	{
		for (Enumeration e=connections.elements(); e.hasMoreElements();)
		{
			Connection c = (Connection) e.nextElement();
			if (c.getIsDefault()) return c;
		}

		return null;
	}

	public Connection getConnection(String name)
	{
		for (Enumeration e=connections.elements(); e.hasMoreElements();)
		{
			Connection c = (Connection) e.nextElement();
			if (c.getTo().equals(name)) return c;
		}

		return null;
	}

	private String id, password;
	private boolean askserver = false;

	private Vector hosts = new Vector();
	private Vector connections = new Vector();
	public class Connection
	{
		public Connection(String from, String to)
		{
			this(from, to, false);
		}

		public Connection(String from, String to, boolean isDefault)
		{
			this.from = from;
			this.to = to;
			this.isDefault = isDefault;
		}

		public boolean getIsDefault() { return isDefault; }
		public String getFrom() { return from; }
		public String getTo() { return to; }

		private String from, to;
		private boolean isDefault;
	}
}
